#include <stdio.h>

#ifndef tipi
#include "types/tipisd.h"
#endif

#include <string.h>
#include <stdlib.h>
#include "pile.h"
#include <openssl/sha.h>

#define nu 1000

typedef struct thash{
	
	chiave right;
	chiave middle;
	chiave left;
	} thash;

int creachiavi(nodosd *sdtree, long numeroutenti);
int tsha1(chiave label, thash *triple);
void popola(chiave label,nodosd *sdtree,long padre,long numeroutenti);
void stampachiave(thash triple);
	
/*	
int main(){ //toglierlo!!!!!!!!!!!
	
	nodosd albero[nu];
	int i;
	
	memset(albero,0,nu*sizeof(long));
	creachiavi(albero,nu);
	for (i=0;i<nu;i++){
		stampa(albero[nu].longkeys);
	}
	return 0;
}*/


int creachiavi(nodosd *sdtree,long numeroutenti){

	chiave label;
	long nodo;
	
	for (nodo=0;nodo<numeroutenti;nodo++){
		SHA1(&nodo,sizeof(long),label); //calcolo una label, in verit questa dovrebbe essere basata su un valore casuale
		popola(label,sdtree,nodo,numeroutenti); //popolo il sottoalbero radicati in nodo
	}
	return 0;
}

//Funzione che popola di chiavi il sittoalbero radicato in i
void popola(chiave label,nodosd *sdtree,long padre,long numeroutenti){
	
	thash *triple;
	
	triple=(thash *)malloc(sizeof(thash));
	if (padre<=numeroutenti){
		tsha1(label,triple);
		push(&(sdtree[padre].longkeys),triple->middle); //inserisco una chiave a lungo termine
		//printf("creata!\n");
		(sdtree[padre].nlong)++; //aggiorno il numero di chiavi a lungo termine
		popola(triple->right,sdtree,(padre*2)+1,numeroutenti); //faccio lo stesso sul sottoalbero dx
		popola(triple->left,sdtree,(padre*2)+2,numeroutenti); //faccio lo stesso sul sottoalbero sx
	}
	free(triple);
}



//funzione che prende una label e restituisce nella struttura triple 
//tre valori di hash calcolati in base alla label
int tsha1(chiave label, thash *triple){
	
	char *templabel;
	chiave hashvalue;
		
	if (!(templabel=(char *) malloc(sizeof(char) * 20+sizeof(int)))){ //alloco la memoria per la label modificata
		return 0;
	}
	memcpy(templabel,label,20); //nella prima parte ci metto la label
	templabel[sizeof(char) * 20]=1;
	SHA1(templabel,sizeof(char) * 20+sizeof(int),hashvalue);
	memcpy(triple->right,hashvalue,20);
	templabel[sizeof(char) * 20]=2;
	SHA1(templabel,sizeof(char) * 20+sizeof(int),hashvalue);
	memcpy(triple->middle,hashvalue,20);
	templabel[sizeof(char) * 20]=3;
	SHA1(templabel,sizeof(char) * 20+sizeof(int),hashvalue);
	memcpy(triple->left,hashvalue,20);
	free(templabel);
	return 1;
}

void stampachiave(thash triple){
	
	int i;
	
	printf("right: ");
	for (i=0;i<20;i++) {
		printf("%c",triple.right[i]);
	}
	printf("\n");
	printf("middle: ");
	for (i=0;i<20;i++) {
		printf("%c",triple.middle[i]);
	}
	printf("\n");
	printf("left: ");
	for (i=0;i<20;i++) {
		printf("%c",triple.left[i]);
	}
	printf("\n");
}
