#include "communication.h"
#include <stdlib.h>
#include <string.h>
#include <stddef.h>

int Decifra(chiave nuova, long i, long j, nodosd *utenti, long nutenti)
{
	listachiavi *l;


	/* se il nodo i-esimo dell'albero SD non e' sotteso dal nodo j-esimo dello stesso albero...*/
	if(i!=j)
	{
		/*...se il nodo non e' una foglia, allora non esegue alcuna operazione tranne che richiamare la funzione Decifra sui suoi figli */
		if((2*i+1)<(nutenti*2)-1 && (2*i+2)<(nutenti*2)-1)
		{
			if(!Decifra(nuova,i*2+1,j,utenti,nutenti))
			{
				return FALSE;
			}
			if(!Decifra(nuova,i*2+2,j,utenti,nutenti))
			{
				return FALSE;
			}
			return TRUE;
		}
		/* se il nodo i-esimo e' una foglia che fa parte dell'Sij in grado di decifrare il messaggio (ovvero se i non e' uno dei nodi sottesi da j e se i e' un nodo valido, con 	indice<nutenti)...*/
		else if(i<(nutenti*2))
		{

			/* alloca lo spazio per la nuova chiave nella lista delle chiavi a breve termine del nodosd i */
			if(!(l=malloc(sizeof(listachiavi))))
			{
				return FALSE;
			}


			memcpy(l->valore,nuova,SHA_DIGEST_LENGTH);
			/* inserisce la nuova chiave in testa alla lista delle chiavi a breve termine di i */
			l->next=(utenti[(i-nutenti+1)]).shortkeys;
			(utenti[(i-nutenti+1)]).shortkeys=l;
			//printf("Do' la chiave %d a %ld (era %ld)\n",(int)nuova[0],(i-nutenti+1),i);
		}
	}
	return TRUE;
}


/* Broadcast(): simula l'invio in broadcast della chiave <nuova> a tutti gli utenti, cifrata in modo tale che solo gli utenti legittimi (quelli contenuti nella lista <destinatari>) possano leggerla.*/
int Broadcast(chiave nuova, listasij *destinatari, nodosd *utenti, long nutenti)
{

	listasij *dadecifrare;
	listachiavi *l;
	long i;


	dadecifrare=destinatari;

	while(dadecifrare!=NULL)
	{
		/* se si tratta di un utente del classic LKH... */
		if(dadecifrare->i==dadecifrare->j)
		{
			/*... inserisce direttamente la chiave nel suo insieme di chiavi a breve termine */
			i=dadecifrare->i;
			
			/* alloca lo spazio per la nuova chiave nella lista delle chiavi a breve termine del nodosd i */
			if(!(l=malloc(sizeof(listachiavi))))
			{
				return FALSE;
			}


			memcpy(l->valore,nuova,SHA_DIGEST_LENGTH);
			/* inserisce la nuova chiave in testa alla lista delle chiavi a breve termine di i */
			l->next=(utenti[i-nutenti+1]).shortkeys;
			(utenti[i-nutenti+1]).shortkeys=l;
		}
		/* se si tratta di un subset (quindi dell'algoritmo HSD)...*/
		else
		{
			/* ... invia la chiave cifrata in modo che soltanto gli utenti che appartengono a quel subset possano decifrarla */
			//printf("INVIO LA CHIAVE %d a (%ld,%ld)\n",(int) nuova[0],dadecifrare->i,dadecifrare->j);
			if (Decifra(nuova,dadecifrare->i,dadecifrare->j,utenti,nutenti)==FALSE)
			{
				return FALSE;
			}
		}
		dadecifrare=dadecifrare->next;
	}
	//printf("\n\n");

	return TRUE;

}

void EliminaChiave(chiave vecchia, nodosd *utenti, long nutenti, long utenteiniziale)
{
	listachiavi *p,*q;
	long i;
	q=NULL;
	
	//printf("utenteiniziale: %ld,nutenti: %ld\n",utenteiniziale,nutenti);
	for(i=utenteiniziale;i<(utenteiniziale+nutenti);i++)
	{

		p=utenti[i].shortkeys;
		if(p!=NULL)
		{
			if(!memcmp(p->valore,vecchia,SHA_DIGEST_LENGTH))
			{
				utenti[i].shortkeys=p->next;
				free(p);
			}
			else
			{
				while(p!=NULL)
				{
					if(!memcmp(p->valore,vecchia,SHA_DIGEST_LENGTH))
					{
						q->next=p->next;
						free(p);
						break;
					}
					q=p;
					p=p->next;
				}
			}
		}
	}
}
