#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include "lkh.h"
#include "lkhutil.h"

long Cerca(Sij *insieme, long cardinalita, Sij dacercare)
{
	long i;

	for(i=0;i<cardinalita && !(insieme[i].i==dacercare.i && insieme[i].j==dacercare.j);i++);

	return (i==cardinalita) ? FALSE : TRUE;
}



/* Differenza(): calcola la differenza tra <insieme1> e <insieme2> (ovvero l'insieme costituito dagli Sij che appartengono ad <insieme1> ma non ad <insieme2>), pone in <differenza> tale insieme e ne restituisce la cardinalita' in caso di successo, ERRORE altrimenti. */
long Differenza(Sij *insieme1, Sij *insieme2, long dim1, long dim2, Sij **differenza)
{
	long ndiff;
	long i;
	long k;

	if(!insieme1)
	{
		*differenza=NULL;
		return 0;
	}
	else if(!insieme2)
	{
		if((*differenza=calloc(dim1,sizeof(Sij)))==NULL)
		{
			return ERRORE;
		}

		for(i=0;i<dim1;i++)
		{
			(*differenza)[i]=insieme1[i];
		}
		return dim1;
	}
	else
	{
		ndiff=4;
		if((*differenza=calloc(ndiff,sizeof(Sij)))==NULL)
		{
			return ERRORE;
		}
		k=0;

		for(i=0;i<dim1;i++)
		{
			if(Cerca(insieme2,dim2,insieme1[i])==FALSE)
			{
				(*differenza)[k].i=insieme1[i].i;
				(*differenza)[k].j=insieme1[i].j;
				k++;
				if(k==ndiff)
				{
					ndiff*=2;
					if(((*differenza)=realloc(*differenza,ndiff*sizeof(Sij)))==NULL)
					{
						return ERRORE;
					}
				}
			}
		}

		return k;
	}

}



/* Min(): restituisce il minore tra val1 e val2 */
long Min(long val1, long val2)
{
	return (val1<val2) ? val1 : val2;
}

/* ListCat(): concatena lista2 a lista1 */
void ListCat(listasij **l1, listasij *l2)
{
	listasij *fine;


	if(*l1==NULL)
	{
		*l1=l2;
	}
	else if(l2!=NULL)
	{
		fine=*l1;
		while(fine->next!=NULL)
		{
			fine=fine->next;
		}
		fine->next=l2;
	}
}

