/* FINIRE DI COPIARE DAL MAIN DI VERS 5
*/

#include <stdio.h>
#include <stdlib.h>
#ifndef TIPI
#include "tipi.h"
#endif
#include "lkh.h"
#include "steiner.h"
#include <string.h>
#include "creasij.h"
#include "classiclkh.h"

//costanti che definiscono i tipi di argomenti disponibili
#define HSD 1
#define LKH 2
#define BOTH 3


/* in totale ci sono al max 10 file (piu' uno riassuntivo) in cui si salvano i dati dell'esecuzioni*/
#define NFILE 10


//costanti che definiscono i tipi di funzioni di revoca disponibili
#define UNIFORME 1
#define ESPONENZIALE 2

#define V if (ambiente.verbose)

//costanti di comodo
/*numero di argomenti che puo prendere il simulatore*/
#define NARG 18
/* nomi dei file di output (escluso il file di riassunto) */
char *nomefile[]=
	{
		"nrevocati.dat",
		"lkh.dat",
		"hsd.dat",
		"nsubset.dat",
		"ins.dat",
		"canc.dat",
		"revocati.dat",
		"subset.dat",
		"bil_lkh.dat",
		"bil_hsd.dat"
	};

//Prototipi funzioni

int crea_ambiente (int argc, char **argv, enviroment * env);
int verifica (chiave sess, sdtree albero);
int errore ();
void swap(long *a,long *b);
void init (enviroment ambiente, l_revocati * lista_revocati, lkh * cstree,
	   lkh * classic, nodosd* utenticlkh);
//void PulisciRevocati (nodosd * utenti, Sij * revocati, long nrevocati);
void PulisciRevocati (nodosd * utenti, long nutenti, long maxrevocati, l_revocati lista_revocati);
void info ();
void Riassunto(int algoritmi);
void Totale(long totlkh, long tothsd);


int
main (int argc, char **argv)
{


  sdtree alberosd;		//albero dell'algoritmo sd
  lkh cstree;			//albero dell'algoritmo cs
  lkh classiclkh;		//struttura dell'algoritmo classico LKH
  l_revocati lista_revocati;	//lista dei revocati
  copertura cover;		//copertura dell'algoritmo sd
  enviroment ambiente;		//ambiente in cui viene eseguito il programma


  nodosd *utenticlkh;		// utenti dell'algoritmo LKH classico



//      variabili di comodo e di apoggio
  long abilitati;              // numero di utenti abilitati al round corrente
  long i,j,k;			//variabile per i cicli
  long niterazioni;	 //numerodi iterazioni della simulazione
  long numeromessaggi;		//numero di messaggi inviati dall'LHK
  chiave sessione;		//la chiave di sessione
  FILE *hsd, *lkh, *nrevocati,*bilancia;		//stream per i files
  long totalehsd,totalelkh; // messaggi totali dell'hsd e dell'lkh

  k=0;
  
  /* cancella i file prodotti da eventuali simulazioni precedenti */
  for(i=0;i<NFILE;i++)
  {
  	remove(nomefile[i]);
  }


  ambiente.alberosd = &alberosd;
  niterazioni=0;
  cover.dimensione=0;
  totalehsd=totalelkh=0;
  cover.elementi=NULL;
  crea_ambiente (argc, argv, &ambiente);
  //alloco la struttura che contiene l'array di revocati
  if (!(lista_revocati.revocati=calloc (alberosd.numerofoglie, sizeof (long))))
    {
      printf ("Errore nell'allocazione della memoria, fatale\n");
      return 0;
    }
  // array degli utenti LKH
  //QUI NON SO QUANTI ELEMENTI VANNO ALLOCATI, IO HO MESSO NUMEROFOGLIE (CHE NON E' NUMEROUTENTI) CRISTIANO
  /* VADA PER NUMERO FOGLIE, MA VA MODIFICATO QUANDO FACCIAMO L'INSERIMENTO (E LO STESSO VALE PER LE TUE VARIABILI). MAURIZIO */
  if (!(utenticlkh = calloc (alberosd.numerofoglie, sizeof (nodosd))))
    {
      printf ("Errore nell'allocazione della memoria, fatale\n");
      return 0;
    }


  if ((hsd = fopen ("hsd.dat", "w")) == NULL)
    {
      printf ("Impossibile salvare il numero di messaggi su file\n");
      return 0;
    }
  if ((lkh = fopen ("lkh.dat", "w")) == NULL)
    {
      printf ("Impossibile salvare il numero di messaggi su file\n");
      return 0;
    }
   if ((nrevocati = fopen ("nrevocati.dat", "w")) == NULL)
    {
      printf ("Impossibile salvare il numero di messaggi su file\n");
      return 0;
    }

  V printf ("Entro in init\n");
  init (ambiente, &lista_revocati, &cstree, &classiclkh, utenticlkh);	//inizializzo tutte le strutture dati
  V printf ("Passato init\n");

  //printf("lotto hsd: %ld lotto lkh:%ld\n",ambiente.lotto_hsd,ambiente.lotto_lkh);
  //   DA QUI VEDERE BENE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  while ((alberosd.tot_revocati) < ambiente.finale)
    {
      V printf ("Entro in revoca con num_revocati pari a %ld\n",
		lista_revocati.tot_revocati);
      revoca (&ambiente, &lista_revocati);	//revoco un lotto di utenti
      fprintf(nrevocati,"%ld\n",lista_revocati.tot_revocati);
      V printf ("Esco da revoca con num_revocati pari a %ld\n",
		lista_revocati.tot_revocati);
      if (ambiente.algoritmi != LKH)
      {
      	if (!ambiente.verbose)
	    printf ("%ld\t", lista_revocati.tot_revocati - alberosd.esclusi);
	
        if(lista_revocati.tot_revocati-lista_revocati.primo_hsd>=ambiente.lotto_hsd || (alberosd.tot_revocati) == ambiente.finale)
	{
	 	/*MODIFICA DI MAU*/
	  lista_revocati.primo_hsd+=ambiente.lotto_hsd;
	  /* FINE MODIFICA */
	  V printf ("Entro in calcolasij\n");
	  calcolasij (alberosd, &cover, lista_revocati);
	  V printf ("Esco da calcolasij\n");
	  V printf ("Entro in controlla_copertura\n");
	  if (controlla_copertura(cover,lista_revocati, &alberosd))
	    {			//controllo la copertura
	      printf
		("ERRORE NEL CALCOLO DELLA COPERTURA!!!\nHo %ld insiemi di copertura.\n",
		 cover.dimensione);
	      for (i = 0; i < cover.dimensione; i++)
		{
		  printf ("%ld;%ld\t", (cover.elementi[i]).i, (cover.elementi[i]).j);
		}
	      printf ("\nl_revocati:\n");
	      for (i = 0; i < lista_revocati.tot_revocati; i++)
		{
		  printf ("%ld ", lista_revocati.revocati[i]);
		}
	      printf ("\nI revocati sono:\n");
	      for (i = 0; i < alberosd.numerofoglie; i++)
		{
		  if ((alberosd.albero)[i].revocato)
		    {
		      printf ("%ld ", i+alberosd.numerofoglie-1);
		    }
		}
	      printf ("\n");
	      printf ("Ho %ld revocati.\n", lista_revocati.tot_revocati);
	      printf ("Albero sd:\n");
	      printf ("\tNumero foglie: %ld\n",alberosd.numerofoglie);
	      printf ("\tProssimo: %ld\n",alberosd.prossimo);
	      printf ("\tEsclusi: %ld\n",alberosd.esclusi);
	      printf ("\tTot Revocato: %ld\n",alberosd.tot_revocati);
	      return 0;
	    }
	  V printf ("Esco da controlla_copertura\n");
	 
	  V printf ("Entro in Lkh\n");
	  if (niterazioni != 0 && ambiente.max == 0)

	    {
	      if (NumeroSubset(cstree.nsubsets, cover.dimensione, ambiente.lotto_hsd) == FALSE)
		{
		  printf ("Errore nel numero dei subset!\n");
		  return 0;
		}
	    }
		//FORSE E' MEGLIO CHE LKH PRENDA LE STRUTTURE INTERE E VEDA LEI DI DIVIDERLE
	  numeromessaggi = Lkh (&cstree, cover.elementi, cover.dimensione, alberosd.albero, alberosd.numerofoglie);	//ricalcolo gli insiemi Sij e li passo alla funzione LHK
	  V printf ("Esco da Lkh\n");
	  fprintf (hsd, "%ld\n", numeromessaggi);	// scrive su file il numero di messaggi attuali 
	  V printf ("Entro in sessionkey\n");
	  Sessionkey (cstree, sessione);
	  V printf ("Esco da sessionkey\n");
	  V printf ("Entro in verifica di HSD\n");
	  if (lista_revocati.tot_revocati != alberosd.numerofoglie)	// non ha senso controllare anche quando tutti gli utenti sono stati revocati 

	    {
	      if (verifica (sessione, alberosd) == FALSE)

		{
		  //controllo che la chiave di sessione dell HSD sia posseduta solo dai non revocati
		  printf ("L'algoritmo HSD non ha funzionato al passo %ld!\n",
			  niterazioni);
		  printf (" e con %ld revocati\n", lista_revocati.tot_revocati);
		  return 0;
		}
	    }
	  V printf ("Esco da verifica di HSD\n");
	  if (!ambiente.verbose)
	    printf ("%ld\t", numeromessaggi);
	  V printf ("Sono stati revocati %ld utenti\n", lista_revocati.tot_revocati);
	  niterazioni++;
	  V printf ("il numero utenti :%ld,i messaggi sono:%ld\n", i,
		    numeromessaggi);
	    /* eseguito il controllo sulle chiavi di sessione, non e' piu' necessario mantenere in memoria le chiavi dei revocati, che dunque vengono cancellate.*/
	   V
         printf ("Entro in PulisciRevocati\n");
	
        
	  PulisciRevocati(alberosd.albero,alberosd.numerofoglie,ambiente.lotto_hsd, lista_revocati);
	   V
         printf ("Esco da PulisciRevocati\n");
	 
	 totalehsd+=numeromessaggi;
	}
	else
	{
		printf("-\t");
		fprintf(hsd,"-\n");
		if((bilancia=fopen("bil_hsd.dat","a"))!=NULL)
		{
			fprintf(bilancia,"-\n");
		}
		fclose(bilancia);
	}
      }

     if (ambiente.algoritmi != HSD)
     {
        if (ambiente.algoritmi == LKH)
        {
		if((lista_revocati.primo_lkh + ambiente.lotto_lkh)>ambiente.alberosd->numerofoglie)
			printf ("%ld\t", ambiente.alberosd->numerofoglie-alberosd.esclusi);
		else
		        printf ("%ld\t",lista_revocati.primo_lkh + ambiente.lotto_lkh-alberosd.esclusi);
        }
     	if( (lista_revocati.tot_revocati-lista_revocati.primo_lkh>=ambiente.lotto_lkh) || (alberosd.tot_revocati) == ambiente.finale)
     	{

         V printf ("Entro in RevocaClassicLkh\n");
      /*   nrevclkh =
         RevocaClassicLkh (utenticlkh, darevclkh, revattclkh, num_foglie,
         utentirevocati, revocaticlkh);*/
        // revattclkh = totrevclkh;

         V
         printf ("Esco da RevocaClassicLkh\n");
         //totrevclkh+=nrevclkh;
         V
         printf ("Entro in ClassicLkh\n");

         numeromessaggi =
         ClassicLkh (classiclkh,&lista_revocati,ambiente,utenticlkh,ambiente.alberosd->numerofoglie);

         V
         printf ("Messaggi totali LKH: ");
         printf ("%ld", numeromessaggi);
         fprintf (lkh, "%ld\n", numeromessaggi);        // scrive su file il numero di messaggi attuali
         V
         printf ("Esco da ClassicLkh\n");
         Sessionkey (classiclkh, sessione);
         V
         printf ("Entro in VerificaClassicLkh\n");
         if (lista_revocati.tot_revocati !=ambiente.alberosd->numerofoglie)        // non ha senso controllare anche quando tutti gli utenti sono stati revocati
         {
        	 if (VerificaClassicLkh (sessione, utenticlkh, ambiente.alberosd->numerofoglie) ==
         FALSE)
         	{
         	//controllo che la chiave di sessione dell'LKH sia posseduta solo dai non revocati
         		printf("L'algoritmo LKH non ha funzionato al passo %ld!\n",
         niterazioni);
         		printf (" e con %ld revocati\n", lista_revocati.tot_revocati);
         		return 0;
         	}
         }
         V
         printf ("Esco da VerificaClassicLkh\n");


	  V
         printf ("Entro in PulisciRevocati\n");

	   /* eseguito il controllo sulle chiavi di sessione, non e' piu' necessario mantenere in memoria le chiavi dei revocati, che dunque vengono cancellate.*/

	 	PulisciRevocati (utenticlkh,alberosd.numerofoglie,ambiente.lotto_lkh, lista_revocati);
	 V
         printf ("Esco da PulisciRevocati\n");
	 totalelkh+=numeromessaggi;
	}
	else
	{
		printf("-\t");
		fprintf(lkh,"-\n");
		if((bilancia=fopen("bil_lkh.dat","a"))!=NULL)
		{
			fprintf(bilancia,"-\n");
		}
		fclose(bilancia);
	}


      }
         printf ("\r");

         if ((ambiente.max != 0) && (alberosd.esclusi > 0))
         {

			//AGGIORNARE LREVOCATI
		abilitati = inserisci(alberosd.albero, ambiente.min, ambiente.max, alberosd.prossimo, alberosd.numerofoglie);
		V printf("Abilito %ld utenti!\n",abilitati);
		if(AbilitaClassicLkh(classiclkh,utenticlkh,alberosd.numerofoglie,alberosd.prossimo,abilitati)==ERRORE)
		{
			printf("Errore nell'inserimento di utenti nell'alg. LKH\n");
			return 0;
		}
         
		//aggiorno i dati dell'albero
		alberosd.prossimo = alberosd.prossimo + abilitati;
		alberosd.esclusi = alberosd.esclusi - abilitati;
		lista_revocati.tot_revocati=lista_revocati.tot_revocati-abilitati;
		lista_revocati.primo_hsd-=abilitati;
		lista_revocati.primo_lkh-=abilitati;
		//elimino gli abilitati dal'array dei revocati
		j=0;
		for(i=abilitati;i<lista_revocati.tot_revocati+abilitati;i++){
			lista_revocati.revocati[j]=lista_revocati.revocati[i];
			j++;
		}
	}
 	V printf("alberosd.tot_revocati=%ld  (<) ambiente.finale=%ld\n",alberosd.tot_revocati, ambiente.finale);
    }
  fclose (lkh);
  fclose (hsd);
  fclose (nrevocati);
  /* prima di uscire, crea il file riassuntivo della simulazione */
  Riassunto(ambiente.algoritmi);
  Totale(totalelkh,totalehsd);
  
  V printf ("L'algoritmo e' stato eseguito con successo\n");
  return 0;
}

void
init (enviroment ambiente, l_revocati * lista_revocati, lkh * cstree,
      lkh * classic, nodosd *utenticlkh)
{

  initsd (ambiente.alberosd, lista_revocati);
  initlkh (cstree, ambiente.numerofigli, ambiente.sbilanciamento);
  
   if (InitClassicLkh(classic, ambiente.alberosd->numerofoglie-1, ambiente.numero_utenti, ambiente.numerofigli,
       ambiente.sbilanciamento, utenticlkh) == ERRORE)
    {
      printf ("Errore nell'inizializzazione delle strutture datim fatale\n");
      exit (0);
    }
}


void Riassunto(int algoritmi)
{
	FILE *f[NFILE]; 
	FILE *riassunto;
	char buffer[10000]; // buffer per la lettura da file
	char *newline;
	/* maschere che indicano i file da inserire in riassunto.dat a seconda degli algoritmi eseguiti nella simulazione */
	int both[]={TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,};
	int lkh[]={TRUE,TRUE,FALSE,FALSE,FALSE,FALSE,TRUE,FALSE,TRUE,FALSE};
	int hsd[]={TRUE,FALSE,TRUE,TRUE,TRUE,TRUE,TRUE,TRUE,FALSE,TRUE};
	
	int i;
	int *daaprire;
	
	
	
	/* crea il file del riassunto */
	if((riassunto=fopen("riassunto.dat","w"))==NULL)
	{
		printf("Errore nella creazione del file riassuntivo della simulazione\n");
		exit(0);
	}
	
	
	
	
	
	/* apre i file prodotti nel corso della simulazione (solo quelli prodotti nel corso della simulazione appena terminata, e nessun altro!) */
	
	if(algoritmi==BOTH)
	{
		daaprire=both;
	}
	else if(algoritmi==LKH)
	{
		daaprire=lkh;
	}
	else if(algoritmi==HSD)
	{
		daaprire=hsd;
	}
	else
	{
		printf("Errore interno\n");
		exit(0);
	}

	
	/* per ogni file...*/
	for(i=0;i<NFILE;i++)
	{
		/* se e' tra quelli prodotti nel corso della precedente simulazione, ovvero se e' uno dei file da aprire per includere i suoi dati nel riassunto...*/
		if(*daaprire)
		{
			/*...allora lo apre!*/
			if((f[i]=fopen(nomefile[i],"r"))==NULL)
			{
				printf("1Errore nella creazione del file riassuntivo della simulazione\n");
				exit(0);
			}
		}
		else
		{
			f[i]=NULL;
		}
		daaprire++;
	}
	
		
	/* finche' non e' terminata la scansione del file nrevocati.dat (quello che contiene il numero dei revocati totali, round per round) */
	while(!feof(f[0]))
	{
		/* per ogni file che e' stato aperto...*/
		for(i=0;i<NFILE;i++)
		{
			if(f[i]!=NULL)
			{
				/* legge la riga corrente e la scrive all'interno del file riassuntivo, senza l'eventuale carattere di nuova riga  presente (che viene sostituito da un carattere di tabulazione)*/
				if(fgets(buffer,10000,f[i])==NULL)
				{
					if(feof(f[i]))
					{						
						break;
					}
					printf("4Errore nella creazione del file riassuntivo della simulazione nella lettura del file %s\n",nomefile[i]);
					exit(0);
				}
				if((newline=strchr(buffer,'\n')))
				{
					*newline='\t';
				}
				if((fputs(buffer,riassunto)==EOF))
				{
					printf("5Errore nella creazione del file riassuntivo della simulazione\n");
					exit(0);
				}
			}
		}
		/* finita la scansione dei dati del round attuale, va a capo nel file del riassunto*/
		buffer[0]='\n';
		buffer[1]='\0';
		if((fputs(buffer,riassunto)==EOF))
		{
			printf("6Errore nella creazione del file riassuntivo della simulazione\n");
			exit(0);
		}
	}
	
	/* chiude il file del riassunto */
	fclose(riassunto);
	/*chiude ogni file che e' stato aperto in precedenza*/
	for(i=0;i<NFILE;i++)
	{
		if(f[i]!=NULL)
		{
			fclose(f[i]);
		}
	}
	
}

long Somma(char *file)
{
	long totale;
	FILE *f;
	char buffer[100];
	
	if((f=fopen(file,"r"))==NULL)
	{
		return 0;
	}
	
	totale=0;
	
	while(!feof(f))
	{
		if(fgets(buffer,100,f)!=NULL)
		{
			totale+=atol(buffer);
		}
	}
	return totale;
}
void Totale(long totlkh, long tothsd)
{
	FILE *ftot;
	
	if((ftot=fopen("totale.dat","w"))==NULL)
	{
		printf("Errore: impossibile salvare su file il numero totale di messaggi\n");
	}
	else
	{
		fprintf(ftot,"HSD\tTotale messaggi senza bilanciamento: %ld\n",tothsd);
		fprintf(ftot,"HSD\tTotale messaggi con bilanciamento: %ld\n",tothsd+Somma(nomefile[NFILE-1]));
		fprintf(ftot,"LKH\tTotale messaggi senza bilanciamento: %ld\n",totlkh);
		fprintf(ftot,"LKH\tTotale messaggi con bilanciamento: %ld\n",totlkh+Somma(nomefile[NFILE-2]));
		fclose(ftot);
	}
}

int errore ()
{
  printf ("Uso del programma errato!\n");
  info ();
  return 0;
}

int
verifica (chiave sess, sdtree albero)
{
  int i;
  listachiavi *l;
  long nutenti;
  nodosd *utenti;
  
  nutenti=albero.numerofoglie;
  utenti=albero.albero;
  for (i = 0; i < nutenti; i++)
    {
      l = (utenti[i]).shortkeys;
      while (l != NULL && memcmp (l->valore, sess, SHA_DIGEST_LENGTH) != 0)
	{
	  l = l->next;
	}
      if ((l != NULL && utenti[i].revocato))
	{
	  printf ("\nL'utente %d ha la chiave ma e' revocato\n", i);
	  //...c'e' un errore!
	  return FALSE;

	}
      if ((l == NULL && !(utenti[i].revocato)))
	{
	  printf ("\nL'utente %d non ha la chiave ma e' legittimo (revocato vale %d)\n", i,utenti[i].revocato);
	  printf ("\nPer l'utente successivo %d revocato vale %d\n", i+1,utenti[i+1].revocato);
	  //...c'e' un errore!
	  return FALSE;
	}
	/*else
	{
		printf("L'utente %d e' a posto\n",i);
	}*/
    }
  return TRUE;
}

	/* PulisciRevocati(): Elimina le chiavi a breve termine degli utenti che sono stati revocati (viene chiamata dopo la verifica sulla chiave di sessione, dunque l'eliminazione di tali chiavi non va ad inficiare il funzionamento degli algoritmi ma semplicemente ne migliora le prestazioni diminuendone l'occupazione di memoria). */

void PulisciRevocati (nodosd * utenti, long nutenti, long maxrevocati, l_revocati lista_revocati)
{
  listachiavi *l, *app;
  long dacancellare, i;

  for (i =(lista_revocati.tot_revocati-1); i >=0 && i>=(lista_revocati.tot_revocati-maxrevocati);i--)
    {
    	
      dacancellare = (lista_revocati.revocati)[i]-nutenti+1; /* calcola la posizione che ricopre nell'array degli utenti l'utente di etichetta i */
      if(dacancellare>=0 && dacancellare<nutenti)
      {
           //printf("i vale %ld dacancellare vale %ld\n",i,dacancellare);
      	l = (utenti[dacancellare]).shortkeys;
      	while (l != NULL)
	{
	  app = l->next;
	  free (l);
	  l = app;
	}
      	(utenti[dacancellare]).shortkeys = NULL;
      }

    }
}


/*void
PulisciRevocati (nodosd * utenti, Sij * revocati, long nrevocati)
{
  listachiavi *l, *app;
  long dacancellare, i;

  for (i = 0; i < nrevocati; i++)
    {
      dacancellare = revocati[i].i;
      l = (utenti[dacancellare]).shortkeys;
      while (l != NULL)
	{
	  app = l->next;
	  free (l);
	  l = app;
	}
      (utenti[dacancellare]).shortkeys = NULL;

    }
}
*/

void
info ()
{

  printf ("Simulatore HSD\\LKH\n");
  printf ("Opzioni:\n");
  printf ("-h\t\tStampa questo messaggio\n");
  printf
    ("-r numero:\tIndica quanti utenti si devono revocare ogni round (default vale 1)\n");
  printf ("-v\t\tAttiva la verbosit per il debugging\n");
  printf
    ("-n numero:\tIndica il numero di utenti utilizzati per la simulazione (default vale 16)\n");
  printf
    ("-p numero:\tIndica lo sbilanciamento massimo ammesso dall'albero lkh utilizzato in HSD (default 1)\n");
  printf
    ("-t numero:\tIndica il massimo degli utenti da revocare (default vale -n)\n");
  printf
    ("-f numero:\tIndica il numero di figli per nodo dell'albero lkh utilizzato in HSD (default 3)\n");
  printf
    ("-a lkh|hsd|both:\tIndica quale algoritmo usare per la simulazione\n");
  printf
    ("-func u|e:\tSceglie il tipo di funzione di revoca, u per uniforme (default), e per esponenziale (non implementata)\n");
    exit(0);
    
}


int
crea_ambiente (int argc, char **argv, enviroment * env)
{

  long potenza = 1;
  int i;


  env->sbilanciamento = 1;	//default per lo sbilanciamento per l'albero lkh
  env->numerofigli = 3;		//numerofigli per l'albero lkh
  env->lotto_hsd = 1;		//dimensioni del lotto di revoca per hsd
  env->lotto_lkh = 1;		//dimensioni del lotto di revoca per lkh
  env->verbose = 0;		//flag che attiva la verbosit del simulatore
  env->finale = 0;		//numero massimo di utenti da revocare
  env->max = 0;			//numero minimo e massimo di utenti da riabilitare ad ogni round
  env->numero_utenti = 16;
  env->finale = 1;
  env->algoritmi=BOTH;

  if (argc > NARG)
    {				//se i parametri sono troppi
      errore ();
      return 0;
    }
  for (i = 1; i < argc; i++)
    {				//estraggo i parametri da riga di comando
      if (!strcmp (argv[i], "-p"))
	{			//setta lo sbilanciamento dell'albero hkl
	  sscanf (argv[++i], "%d", &(env->sbilanciamento));
	}
      else if (!strcmp (argv[i], "-n"))
	{
	  sscanf (argv[++i], "%ld", &(env->numero_utenti));
	}
      else if (!strcmp (argv[i], "-r"))
	{
	  sscanf (argv[++i], "%ld", &(env->lotto_hsd));
	  env->lotto_lkh = env->lotto_hsd;
	}
      else if (!strcmp (argv[i], "-rh"))
	{
	  sscanf (argv[++i], "%ld", &(env->lotto_hsd));
	}
      else if (!strcmp (argv[i], "-rl"))
	{
	  sscanf (argv[++i], "%ld", &(env->lotto_lkh));
	}
      else if (!strcmp (argv[i], "-f"))
	{
	  sscanf (argv[++i], "%d", &(env->numerofigli));
	}
      else if (!strcmp (argv[i], "-v"))
	{
	  env->verbose = 1;
	}
      else if (!strcmp (argv[i], "-h"))
	{
	  info ();
	  exit(0);
	}
      else if (!strcmp (argv[i], "-t"))
	{
	  sscanf (argv[++i], "%ld", &(env->finale));
	}
      else if (!strcmp (argv[i], "-a"))
	{
	  if (!strcmp (argv[++i], "lkh"))
	    {
	      env->algoritmi = LKH;
	    }
	  else if (!strcmp (argv[i], "hsd"))
	    {
	      env->algoritmi = HSD;
	    }
	  else if (!strcmp (argv[i], "both"))
	    {
	      env->algoritmi = BOTH;
	    }
	  else
	    {
	      errore ();
	      return 0;
	    }
	}
      else if (!strcmp (argv[i], "-func"))
	{
	  if (!strcmp (argv[i], "u"))
	    {
	      env->funzione = UNIFORME;
	    }
	  else
	    {
	      errore ();
	      return 0;
	    }
	}
//              else if(!strcmp(argv[i],"-trust")){
//                      sscanf(argv[++i],"%f",&trust);
//              }
      else if (!strcmp (argv[i], "-x"))
	{
	  sscanf (argv[++i], "%ld", &(env->min));
	  sscanf (argv[++i], "%ld", &(env->max));
	}
      else
	{
	  errore ();
	  return 0;
	}
    }


  //controllo che non siano stati inseriti valori incompatibili
  if ((env->numero_utenti < 1) || (env->sbilanciamento < 1)
      || /*(env->trust<0)|| */ (env->max < 0) || (env->min < 0)
      || (env->numero_utenti < 1) || (env->lotto_lkh < 1)
      || (env->lotto_hsd < 1) || (env->numerofigli <= 1) || (env->finale < 1))
    {
      errore ();
      return 0;
    }
    
   if(env->algoritmi==LKH)
   {
   	env->lotto_hsd =env->lotto_lkh;
   }
   else if(env->algoritmi==HSD)
   {
   	env->lotto_lkh = env->lotto_hsd;
   }
  //setto i valori della struttura alberosd
  while (env->numero_utenti > potenza)
    {				//cerco la potenza di due subito maggiore di num_foglie
      potenza = potenza * 2;
    }
  if (env->numero_utenti < potenza)
    {
      env->alberosd->numerofoglie = potenza;	//pondo num_foglie pari alla potenza di 2 (indisponsabile per sd)
    }
  env->alberosd->numerofoglie = potenza;
  env->alberosd->esclusi = potenza - env->numero_utenti;
  env->alberosd->tot_revocati = 0;
  env->alberosd->prossimo = env->alberosd->numerofoglie - env->alberosd->esclusi;

  if (env->finale == 1 && env->max == 0)	//se non  specificato di agiungere utenti l'algoritmo termina sugli n utenti di input
    {
      env->finale = env->alberosd->numerofoglie - env->alberosd->esclusi;
    }
  else if (env->finale == 1 && env->max != 0)
    {
      env->finale = env->alberosd->numerofoglie;	//se  specificato di agiungere utenti l'algoritmo termina sugli tutte le foglie del'alberosd
    }
  return 1;
}
