#include <stdio.h>
#include <stdlib.h>
#include <openssl/rand.h>
#include <openssl/err.h>
#ifndef TIPI
#include "tipi.h"
#endif


long
abilitati (long *l_abilitati, nodosd * sdtree, long numero)
{
  long i, j = 0;

  for (i =0; i < numero; i++)
    {
      if (sdtree[i].revocato == 0)
	{
	  l_abilitati[j] = i;
	  j++;
	}
    }
  return j;
}


void
initsd (sdtree * alberosd,l_revocati *lista_revocati)
{

  int i;
  
  lista_revocati->tot_revocati=0;
  lista_revocati->primo_hsd=0;
  lista_revocati->primo_lkh=0;
  alberosd->albero = calloc ((alberosd->numerofoglie), sizeof (nodosd));	// l'inizializzazione 
  // dei campi non serve poich calloc setta la memoria a 0
//   printf("Prossimo: %ld\n",alberosd->prossimo);
  
  for (i = alberosd->prossimo; i < alberosd->numerofoglie; i++)
    {				// revoco gli utenti in eccesso
      (alberosd->albero)[i].revocato = 1;
	//aggiungo l'utente revocato nell'array dei revocati
		lista_revocati->tot_revocati++;
		(lista_revocati->revocati)[lista_revocati->tot_revocati-1]=i+alberosd->numerofoglie-1;
    }
   lista_revocati->primo_hsd=lista_revocati->tot_revocati;//i-1;
   //lista_revocati->primo_lkh=lista_revocati->tot_revocati++;
   lista_revocati->primo_lkh=lista_revocati->tot_revocati;
//    printf("tot rev:%ld\n",lista_revocati->tot_revocati);
}



// funzione cha inserisce randomicamente da min a max utenti dell'albero
// sd, a partire da ultimo (indice del primo utente da abilitare)
// restituisce il numero di utenti abilitati
long
inserisci (nodosd * sdtree, long min, long max, long ultimo,
	   long numeroutenti)
{

  unsigned long e;
  long attuale, i;

  if (!(RAND_bytes ((char *) &attuale, sizeof (long))))
    {				// genero un long randomico e lo metto in attuale
      e = ERR_get_error ();	// prendo il codice di errore
      printf ("%s", ERR_error_string (e, NULL));	// stampo la stringa di
      // errore
      exit (0);
    }
  if (max == min)
    {
      attuale = max;
    }
  else
    {
      attuale = (abs (attuale) % (max - min + 1)) + min;	// genero il numero di
      // utenti da revocare
    }
  if (ultimo + attuale >numeroutenti)
    {				// se ho revocato pi utenti di quanti disponibili
      attuale = numeroutenti- ultimo;
    }
  for (i = 0; i < attuale; i++)
    {
      sdtree[ultimo + i].revocato = 0;
    }
  //printf ("Ho abilitato %ld utenti\n", attuale);
  return attuale;
}


// funzione che fornisce l'indice di un utente di un albero completo in
// modo randomico
long
fornisci_utente_revocato (sdtree *alberosd)
{

  long attuale, *l_abilitati, tot_abilitati;
  unsigned long e;

  if (!(l_abilitati = malloc (sizeof (long) * (alberosd->numerofoglie - alberosd->tot_revocati))))
    {
      printf ("Errore nela malloc\n");
      exit (0);
    }
  tot_abilitati = abilitati (l_abilitati, alberosd->albero, alberosd->numerofoglie);
  if (!(RAND_bytes ((char *) &attuale, sizeof (long))))
    {				// genero un long randomico e lometo in attuale
      e = ERR_get_error ();	// prendo il codice di errore
      printf ("%s", ERR_error_string (e, NULL));	// stampo la str di errore
      exit (0);
    }
  attuale = (abs (attuale) % tot_abilitati);	// prendo uno degli abilitati
  attuale = l_abilitati[attuale]+alberosd->numerofoglie-1;
  free (l_abilitati);
//   printf("revocato in fur: %ld\n",attuale);
  return attuale;
  ;
}

// alberosd  l'albero degli utenti sd,da rev  il numero di utenti da
// revocare, tot_rev  il numero di utenti gi revocati
// numero  il numero di utenti presenti all'inizio, revocati  
long
revoca (enviroment *ambiente, l_revocati * lista_revocati)
{
  long attuale, cursore = 0;
  long da_rev;			// maggiore tra lotto_lkh e lotto_hsd
  sdtree *alberosd;
  nodosd *albero;

  FILE *frev;

  frev = fopen ("revocati.dat", "a");

  alberosd = ambiente->alberosd;
  albero = alberosd->albero;
  if (ambiente->lotto_hsd < ambiente->lotto_lkh)
    {				// pongo il numero di utenti da revocare pari al lotto maggiore
      da_rev = ambiente->lotto_hsd;
    }
  else
    da_rev = ambiente->lotto_lkh;
  while ((cursore < da_rev) && (alberosd->tot_revocati < ambiente->finale))	
    // revoca  pseudocasuale.
    {
      attuale = fornisci_utente_revocato (alberosd);
	  //printf("Attuale vale %ld\n",attuale);
      fprintf (frev, "%ld ", attuale);
	  //revoco l'utente nell'sd
      albero[attuale-alberosd->numerofoglie+1].revocato = 1;
      //printf("revoco %ld che diventa %ld\n",attuale,attuale-ambiente->numero_utenti+1);
      alberosd->tot_revocati++;
	  //aggiungo l'indice nell'array di revocati
	  (lista_revocati->revocati)[lista_revocati->tot_revocati]=attuale;
	  //printf("lista_revocati->tot_revocati vale: %ld\n",lista_revocati->tot_revocati);
	  //printf("(lista_revocati->revocati)[lista_revocati->tot_revocati] vale:%ld\n",(lista_revocati->revocati)[lista_revocati->tot_revocati]);
	  lista_revocati->tot_revocati++;
      cursore++;
	//MAURIZIO QUESTO A CHE SERVIVA?
//      revocati[*ind] = attuale;
    }

  fprintf (frev, "\n");
  fclose (frev);
  return lista_revocati->tot_revocati;
}


// funzione che calcola lo steiner tree,prende l'albero degli utenti sd,
// il loro numero, il totale dei revocati
// un puntatore allo steiner tree vuoto
// la funzione costruisce, per ogni revocato , l'albero dei padri
long
stainer_tree (long **stain_tree, long numero, nodosd * sdtree,
	      long *l_revocati, long tot_rev)
{
  int cont = 0, c;
  long *appoggio, w, indice, nodo_s = 0;

  appoggio = calloc (2 * numero - 1, sizeof (long));

  if (appoggio == NULL)
    {
      printf ("Errore nella calloc in stainer_tree\n");
      exit (0);
    }

  for (w = 0; w < tot_rev; w++)
    {

      indice = l_revocati[w];
      appoggio[indice] = 1;	// si inserisce il revocato nell'appoggio
      // dello stainer tree
      nodo_s = indice;		// si carica il evocato nella variabile
      // per calcolare i padri del revocato

      while (nodo_s != -1)
	{			// si inseriscono i padri del revocato
	  // nello stainer tree virtuale d'appoggio

	  if ((nodo_s == 1) || (nodo_s % 2) != 0)
	    {
	      nodo_s = (nodo_s / 2);
	    }
	  else
	    {
	      nodo_s = ((nodo_s / 2) - 1);
	    }
	  if (nodo_s > -1)
	    {
	      appoggio[nodo_s] = 1;
	    }
	}
    }

  for (w = 0; w < (2 * numero - 1); w++)	// si conteggiano gli elementi di dello
    // stainer tree d'appoggio
    {
      if (appoggio[w] == 1)
	{
	  cont++;
	}
    }


  if (cont == 0)
    return 0;			/* ehi qui va in seg fault se non si
				 * controlla!! Maurizio */

  if ((*stain_tree = calloc (cont, sizeof (long))) == NULL)
    {
      printf ("Errore nella calloc in stainer_tree\n");
      exit (0);
    }				// viene inizializzato lo stainer tree

  for (w = 0, c = 0; w < (2 * numero); w++)	// si caricano i nodi
    // dello stainer tree da
    // quello virtuale
    // d'appoggio
    {
      if (appoggio[w] == 1)
	{
	  (*stain_tree)[c++] = w;
	}
    }
  free (appoggio);
  return (cont);
}
