#define TIPI

#include <openssl/sha.h>


typedef char chiave[SHA_DIGEST_LENGTH];	//tipo che implementa la chiave sha1 da 160 bit


typedef struct listch
{
  chiave valore;
  struct listch *next;
} listachiavi;

typedef struct sij
{				//tipo che implementa un elemento della lista di indici Sij dell'algoritmo sd
  long i;			//primo indice
  long j;			//secondo indice
} sij;

typedef struct lisij
{				//tipo che implementa un elemento della lista di indici Sij dell'algoritmo sd
  long i;			//primo indice
  long j;			//secondo indice
  struct lisij *next;
} listasij;

typedef struct nodosd
{				//tipo che contiene i dati associati ad un nodo dell'albero SD
  unsigned short revocato;	//flag che ci dice se e' revocato/abilitato, ha senso solo per le foglie
  listachiavi *shortkeys;	//lista di indici di chiavi a breve termine
} nodosd;

typedef struct copertura
{

  sij *elementi;		//array di coppie sij
  long dimensione;		//numero coppie sij
} copertura;


typedef struct sdtree
{				//struttura per l'albero sd e dati relativi

  nodosd *albero;		//array di long che implementa un albero binario completo
  long numerofoglie;		//numero di foglie dell'albero
  long esclusi;			//foglie che sono escluse dal'algoritmo
  long tot_revocati;		//numero di utenti revocati ESCLUSI quelli che non prendono parte all'algoritmo
  long prossimo;		//primo utente il cui indice supera il numero di utenti della simulazione 
} sdtree;

typedef struct l_revocati
{

  long *revocati;		//lista di indici dei revocati
  long tot_revocati;		//totale degli indici revocati
  long primo_lkh;		//primo nuovo revocato per l'algoritmo lkh
  long primo_hsd;		//primo nuovo revocato per l'algoritmo hsd 
} l_revocati;


typedef struct enviroment
{				//struttura ch mantiene l'ambiente di esecuzione del simulatore

  int sbilanciamento;		//sbilanciamento per l'albero lkh
  int numerofigli;		//numerofigli per l'albero lkh
  long lotto_hsd;		//dimensioni del lotto di revoca per hsd
  long lotto_lkh;		//dimensioni del lotto di revoca per lkh
  unsigned short verbose;	//flag che attiva la verbosità del simulatore
  long finale;			//numero massimo di utenti da revocare
  unsigned short algoritmi;	//algoritmo che si intende eseguire
  unsigned short funzione;	//tipo di funzione utilizata per le revoche (implementata solo uniforme)
  long min, max;		//numero minimo e massimo di utenti da riabilitare ad ogni round
  long numero_utenti;		//numero di utenti iniziali dell'albero sd
  sdtree *alberosd;		//reference alla struttura che contiene l'albero sd
} enviroment;
